/**************************************************************************
 *  Copyright (C) 2008 by Simon Qian                                      *
 *  SimonQian@SimonQian.com                                               *
 *                                                                        *
 *  Project:    vsprog                                                    *
 *  File:       vsprog.c                                                  *
 *  Author:     SimonQian                                                 *
 *  Versaion:   See changelog                                             *
 *  Purpose:    configuration file                                        *
 *  License:    See license                                               *
 *------------------------------------------------------------------------*
 *  Change Log:                                                           *
 *      YYYY-MM-DD:     What(by Who)                                      *
 *      2008-10-29:     created(by SimonQian)                             *
 **************************************************************************/
#ifndef __APP_CFG__
#define __APP_CFG__

// platform and compiler
#define MSWIN					1
#define LINUX					2
#define MACOS					3
#define _PLATFORM				MSWIN//LINUX//MSWIN








typedef enum { ERROR_OK = 0, ERROR_FAIL = 1 } RESULT;


// typedefines
typedef unsigned char			uint8;
typedef signed char				int8;
typedef unsigned short			uint16;
typedef signed short			int16;
typedef unsigned int			uint32;
typedef signed int				int32;

// includes
#include "port.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#if _PLATFORM == LINUX
#include <sys/time.h>
#elif _PLATFORM == MSWIN
#include <windows.h>
#endif

#include "tools/hex/hex.h"
#include "tools/pgbar/pgbar.h"
#include "log.h"

#include "vsprog.h"
#include "programmer/programmer.h"
#include "target/target.h"

#define PARAM_CHECK

#if _PLATFORM == MSWIN

#define FILE_SEPARATOR			'\\'
#define sleep_ms(ms)			Sleep(ms)

#elif _PLATFORM == LINUX

#define FILE_SEPARATOR			'/'
#define sleep_ms(ms)			usleep((ms) * 1000)

#endif

#define PROGRESS_STEP			40

#endif		// #ifndef __APP_CFG__

