/**************************************************************************
 *  Copyright (C) 2008 by Simon Qian                                      *
 *  SimonQian@SimonQian.com                                               *
 *                                                                        *
 *  Project:    vsprog                                                    *
 *  File:       vsprog.c                                                  *
 *  Author:     SimonQian                                                 *
 *  Versaion:   See changelog                                             *
 *  Purpose:    Log MACROs                                                *
 *  License:    See license                                               *
 *------------------------------------------------------------------------*
 *  Change Log:                                                           *
 *      YYYY-MM-DD:     What(by Who)                                      *
 *      2008-10-29:     created(by SimonQian)                             *
 **************************************************************************/
#define ERROR_LEVEL				0
#define WARNING_LEVEL			0
#define INFO_LEVEL				1
#define DEBUG_LEVEL				2

#define LOG_DEFAULT_LEVEL		INFO_LEVEL

#if 1
#	define LOG_ERROR(...)		if(verbosity >= ERROR_LEVEL) fprintf(stderr,   "Error: " __VA_ARGS__)
#	define LOG_WARNING(...)		if(verbosity >= WARNING_LEVEL) fprintf(stdout, "Warn : " __VA_ARGS__)
#	define LOG_INFO(...)		if(verbosity >= INFO_LEVEL) fprintf(stdout,    "Info : " __VA_ARGS__)
#	define LOG_DEBUG(...)		if(verbosity >= DEBUG_LEVEL) fprintf(stdout,   "Debug: " __VA_ARGS__)
#	define LOG_BUG(...)			fprintf(stderr, "/****Bug****/: " __VA_ARGS__)
#else
#	define LOG_ERROR			printf
#	define LOG_WARNING			printf
#	define LOG_INFO				printf
#	define LOG_DEBUG			printf
#	define LOG_BUG				printf
#endif
