/**************************************************************************
 *  Copyright (C) 2008 by Simon Qian                                      *
 *  SimonQian@SimonQian.com                                               *
 *                                                                        *
 *  Project:    vsprog                                                    *
 *  File:       programmer.c                                              *
 *  Author:     SimonQian                                                 *
 *  Versaion:   See changelog                                             *
 *  Purpose:    common functions for all programmers                      *
 *  License:    See license                                               *
 *------------------------------------------------------------------------*
 *  Change Log:                                                           *
 *      YYYY-MM-DD:     What(by Who)                                      *
 *      2008-10-29:     created(by SimonQian)                             *
 **************************************************************************/
#include "app_cfg.h"

#include "versaloon/versaloon.h"

programmer_info_t programmers_info[] = 
{
	// versaloon
	{
		VERSALOON_STRING,			// name
		versaloon_check_argument,	// check_argument
		versaloon_init_capability,	// init_capability
	},
	{ NULL }
};

programmer_info_t *cur_programmer = NULL;

RESULT programmer_init(const char *programmer, const char *app_dir)
{
	uint32 i;

	app_dir = app_dir;

	if(programmer != NULL)
	{
		for(i = 0; i < (sizeof(programmers_info) / sizeof(programmers_info[0]) - 1); i++)
		{
			if(!strcmp(programmers_info[i].name, programmer))
			{
				cur_programmer = &programmers_info[i];

				return ERROR_OK;
			}
		}
		return ERROR_FAIL;
	}
	else
	{
		cur_programmer = &programmers_info[PROGRAMMER_DEFAULT];

		return ERROR_OK;
	}
}

void programmer_print_list(void)
{
	uint32 i;

	printf("Supported programmers:\n");
	for(i = 0; i < (sizeof(programmers_info) / sizeof(programmers_info[0]) - 1); i++)
	{
		programmers_info[i].parse_argument('S', NULL, 0);
	}
	printf("\n");
}

