/**************************************************************************
 *  Copyright (C) 2008 by Simon Qian                                      *
 *  SimonQian@SimonQian.com                                               *
 *                                                                        *
 *  Project:    vsprog                                                    *
 *  File:       at89s5x.h                                                 *
 *  Author:     SimonQian                                                 *
 *  Versaion:   See changelog                                             *
 *  Purpose:    functions for at89s5x                                     *
 *  License:    See license                                               *
 *------------------------------------------------------------------------*
 *  Change Log:                                                           *
 *      YYYY-MM-DD:     What(by Who)                                      *
 *      2008-10-29:     created(by SimonQian)                             *
 **************************************************************************/
#define S5X_STRING					"at89s5x"


#define S5X_MAX_FLASH_SIZE			(8 * 1024)
#define S5X_MAX_PAGE_SIZE			256
#define S5X_MAX_PAGE_NUM		

#define S5X_FLASH_CHAR				0xFF
#define S5X_ID_MASK					0xFFFFFFFF

// flash mode
#define S5X_PAGE_MODE				(1 << 0)
#define S5X_BYTE_MODE				(1 << 1)
#define S5X_MODE_MASK				(S5X_PAGE_MODE | S5X_BYTE_MODE)

typedef struct
{
	const char *chip_name;
	uint32 signature;
	uint8 program_mode;
	uint16 flash_page_size;
	uint16 flash_page_num;
	uint16 ee_page_size;
	uint16 ee_page_num;
	uint16 usrsig_page_size;
	uint8 fuse_size;
	uint8 pe_out;
	uint16 flash_size;
	uint16 ee_size;
}s5x_param_t;

extern const program_area_map_t s5x_program_area_map[];

RESULT s5x_parse_argument(char cmd, const char **argu, uint32 argu_len);
RESULT s5x_probe_chip(char *chip_name);
RESULT s5x_check_mode(uint32 *mode);

RESULT s5x_init(program_info_t *pi, const char *dir, programmer_info_t *prog);
RESULT s5x_fini(void);

RESULT s5x_prepare_buffer(program_info_t pi);
RESULT s5x_program(operation_t operations, program_info_t pi, programmer_info_t *prog);

RESULT s5x_write_buffer_from_file_callback(uint32 address, uint32 seg_addr, uint8* data, uint32 length);

RESULT s5x_get_mass_product_data_size(operation_t operations, program_info_t pi, uint32 *size);
RESULT s5x_prepare_mass_product_data(operation_t operations, program_info_t pi, uint8 *buff);

